chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
	// console.log('popop：' + JSON.stringify(request));
	if (request.type == 'ver') {
		sendResponse({ ver: '2' });
	} else if (request.type == 'fetch') {
		fetch('https://jsq.gnxt.vip/app' + request.url, {
			method: 'POST',
			headers: {
				Accept: 'application/json, text/plain, */*',
				'Content-Type': 'application/json',
				Authorization: request.token,
			},
			body: JSON.stringify(request.data),
		})
			.then((res) => res.json())
			.then((res) => {
				sendResponse(res);
				// console.log(res);
			})
			.catch((err) => {
				sendResponse(err);
			});
	} else if (request.type == 'start') {
		var config = {
			mode: 'pac_script',
			pacScript: {
				data: 'var list = [' + request.pac + ']\n' + 'function FindProxyForURL(url, host) {\n' + '   for (var i = 0, l = list.length; i < l; i++) {\n' + '       if (shExpMatch(host, list[i])) {\n' + "           return 'PROXY " + request.link + ";';\n" + '       }\n' + '   }\n' + '}',
			},
		};
		// console.log(config);
		chrome.proxy.settings.set({ value: config, scope: 'regular' });

		chrome.contextMenus.create({ id: 'start', title: '教育加速器正在加速' });
	} else if (request.type == 'stop') {
		chrome.proxy.settings.set({ value: { mode: 'system' }, scope: 'regular' });

		chrome.contextMenus.remove('start');
	} else if (request.type == 'check') {
		chrome.proxy.settings.get({ incognito: false }, function (config) {
			if (config.value.mode == 'pac_script') {
				sendResponse({ status: 'start' });
			} else {
				sendResponse({ status: 'stop' });
			}
		});
	}
	return true;
});

chrome.contextMenus.remove('start', function () {
	if (chrome.runtime.lastError) {
		chrome.proxy.settings.set({ value: { mode: 'system' }, scope: 'regular' });
	} else {
		chrome.contextMenus.create({ id: 'start', title: '教育加速器正在加速' });
	}
});
